/*
 * Classname 			:FieldValidation
 * 
 * Version information	:
 *
 * Date					:13 Dec,2004
 * 
 * Copyright notice		:TCS
 */
package com.tin.tds.lower;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.io.*;

import org.omg.Dynamic.Parameter;

import com.tin.tds.lower.util.Parameters;

/*////////////////      CLASS FOR VALIDATING FIELDS OF A RECORD       ///////////*/

public class FieldValidation implements FileValidatorInterface
{

	/**/ ///////////////      VALIDATE STRING AS INTEGER     /////////////////////**/	        

	boolean isInt(String field)
	{
		if (field.trim() == "" || field.trim().length() == 0)
		{
			return true;
		}

		for (int i = 0; i < field.length(); i++)
		{
			if ((field.charAt(i) < 32 || field.charAt(i) > 127))
			{
				return true;
			}
		}

		try
		{
			Long.parseLong(field.charAt(0)+"");
			Long.parseLong(field.trim());
		}
		catch (Exception e)
		{
			System.out.println("The part added gets called returns true for value "+field);
			return true;
		}

		if (Long.parseLong(field.trim()) < 0)
		{
			return true;
		}
		//System.out.println("Is int gets called return false " + field);
		return (false);
	}

	////////////     Leap year     ////////////////
	private boolean isLeap(int year)
	{
		return ((year % 4 == 0) && (year % 100 != 0 || year % 400 == 0));
	} //METHOD ISLEAP

/**
 * Validates date.Year value should be between 1800 and 2099 .
 * Month between 1 and 12.Day between 1 and 31.For non leap year february 
 * should have 28 days and for leap year february should have 29 days.
 * For 4th,6th,9th,11th month days hsould not be greater than 30.
 */
	protected boolean checkValidation(int iYear, int iMonth, int iDay)
	{

		if ((iYear < 1800) || (iYear > 2099))
			return false;

		if ((iDay < 1) || (iDay > 31) || (iMonth < 1) || (iMonth > 12))
			return false;

		if (!isLeap(iYear) && (iMonth == 2) && (iDay > 28))
			return false;

		if (isLeap(iYear) && (iMonth == 2) && (iDay > 29))
			return false;

		if (((iMonth == 4) || (iMonth == 6) || (iMonth == 9) || (iMonth == 11)) && (iDay > 30))
			return false;

		return true;

	} //METHOD CHECKVALIDATION

	/**/ ///////////////      VALIDATE STRING AS DECIMAL     /////////////////////**/
	boolean isDecimal(String data, int Precision)
	{

		String field = data.trim();
		boolean error = false;
		if (field.trim() == "" || field.trim().length() == 0)
		{
			return true;
		}

		for (int i = 0; i < data.length(); i++)
		{
			if ((data.charAt(i) < 32 || data.charAt(i) > 127))
			{
				return true;
			}
		}

		if(field.charAt(0)=='+')
		{
			return true;
		}
		try
		{
			Double.parseDouble(field);
		}
		catch (Exception e)
		{
			error = true;
			return error;
		}

		int pointCounter = 0;

		char validDecimal;
		int decimalPosition = 0;
		int length = field.length();
		for (int j = 0; j < length; j++)
		{
			if (!(Character.isDigit(field.charAt(j))))
			{
				if (field.charAt(j) == '.')
				{
					pointCounter++;
					decimalPosition = j;
				}
				else
					error = true;
			}
		}

		if (field.charAt(0) == '.')
		{
			return true;
		}

		if (pointCounter == 0)
			error = true;
		else
		{
			if (Precision == (length - 1) - decimalPosition)
				error = false;
			else
				error = true;
		}

		if (pointCounter > 1)
			error = true;

		return error;
	}

	/**/ ///////////////      VALIDATE STRING AS CHARACTER     /////////////////////**/ 

	boolean isChar(String data)
	{
		String field = data.trim();
		if (field.trim() == "" || field.trim().length() == 0)
		{
			return true;
		}
		for (int j = 0; j < field.trim().length(); j++)
		{

			if (!Character.isLetter(field.charAt(j)))
			{
				return (true); // error!
			} //IF
		} //FOR

		return (false);

	} //METHOD isChar

	/**/ ///////////////      CHECK THE DIFFERENCE BETWEEN TWO YEARS IS ONE     /////////////////////**/ 

	public boolean isDifferenceInYearOne(String field)
	{
		if (isNumber(field))
		{

			int assessment_yr = Integer.parseInt(field);
			int first_yr = 0;
			int sec_yr = 0;
			int differenceInYear = 0;
			first_yr = assessment_yr / 100;
			first_yr = first_yr % 100;
			sec_yr = assessment_yr % 100;
			if (first_yr == 99)
			{
				if (sec_yr == 0)
					return (false);
				else
					return (true);
			}
			else
			{
				differenceInYear = sec_yr - first_yr;
				if (differenceInYear == 1)
				{
					return (false);
				}
				else
					return (true); // error!
			}
		}
		else
		{
			return true;
		}

	} //CLOSING isDifferenceInYearOne METHOD

	/**/ ///////////////      CHECK THE DIFFERENCE BETWEEN FINANCIAL YEAR & ASSESSMENT YEAR IS ONE YEARS   /////////////////////**/

	public boolean isAssmentYrFinancialYr(String AssessmentYr, String FinancialYr)
	{

		if (isNumber(AssessmentYr) && isNumber(FinancialYr))
		{
			int assessment_yr = Integer.parseInt(AssessmentYr);
			int financialyr = Integer.parseInt(FinancialYr);
			int first_a, first_f, second_a, second_f, last_a, last_f;
			int Diff1 = 0;
			int Diff2 = 0;

			first_a = assessment_yr / 100;

			second_a = assessment_yr % 100;

			first_f = financialyr / 100;

			second_f = financialyr % 100;

			if (second_f == 99)
			{
				if (second_a == 0)
					return (false);
				else
					return (true);
			}
			else
			{
				Diff1 = first_a - first_f;

				Diff2 = second_a - second_f;

				if ((Diff1 == 1) && (Diff2 == 1))
					return (false);

				else
					return (true);
			}
		}
		else
		{
			return true;
		}

	} //CLOSING isAssmentYrFinancialYr METHOD

	/**/ ///////////////      VALIDATE STRING AS NULL     /////////////////////**/ 	

	boolean isFieldNull(String text)
	{

		if (text.trim() == "" || text.trim().length() == 0)
		{
			return true;
		}

		if (text.length() == 0)
			return (true);
		else
			return (false);

	} //CLOSING METHOD isFieldNull

	/**/ ///////////////      VALIDATE DATE     /////////////////////**/ 	   

	boolean isDate(String date1) //date in ddmmyy form
	{
		if (date1.trim() == "" || date1.trim().length() == 0 || date1.trim().length() != 8 || date1.length() != 8)
		{
			return true;
		}
		boolean errorDate;
		String yy = date1.substring(4, 8);
		String mm = date1.substring(2, 4);
		String dd = date1.substring(0, 2);

		try
		{
			if (checkValidation(Integer.parseInt(yy), Integer.parseInt(mm), Integer.parseInt(dd)))
			{
				errorDate = false;
			}
			else
			{
				errorDate = true;
			}
		}
		catch (Exception e)
		{
			errorDate = true;
		}
		return errorDate;

	} //CLOSING METHOD ISDATE 

	/**/ ///////////////      COMPARE TWO VALID DATES     /////////////////////**/         

	public int compareDate(String date1, String date2)
	{
		if (date1.trim().length() != 8 || date1.length() != 8 || date2.trim().length() != 8 || date2.length() != 8)
		{
			return 5;
		}

		if (isNumber(date1) && isNumber(date2))
		{
			Calendar cal1 = new GregorianCalendar(Integer.parseInt(date1.substring(4, 8)), Integer.parseInt(date1.substring(2, 4)) - 1, Integer.parseInt(date1.substring(0, 2)));

			Calendar cal2 = new GregorianCalendar(Integer.parseInt(date2.substring(4, 8)), Integer.parseInt(date2.substring(2, 4)) - 1, Integer.parseInt(date2.substring(0, 2)));

			if (cal1.after(cal2))
				return 1;
			else
				return 2;
		}
		else
			return 4;
	}

	/**/ ///////////////   VALIDATE STRING AS ALPHANUMERIC          /////////////////////**/         	   

	boolean isAlphaNum(String data)
	{
		String field = data.trim();
		if (field.trim() == "" || field.trim().length() == 0)
		{
			return true;
		}
		for (int j = 0; j < field.length(); j++)
		{
			if (!Character.isLetterOrDigit(field.charAt(j)))
			{
				return true;
			}
		}
		return false;
	} // 	 METHOD  isAlphaNum
	/*    
	    boolean isValidCharString(String dataString){
	       return isValidCharString(dataString, false);
	    }*/

	boolean isValidCharString(String dataString)
	{

		if (dataString.trim() == "" || dataString.trim().length() == 0)
		{
			return true;
		}
		for (int i = 0; i < dataString.length(); i++)
		{
			if ((dataString.charAt(i) < 32 || dataString.charAt(i) > 127) && dataString.charAt(i) != '\n' && dataString.charAt(i) != '\t')
			{
				return true;
			}
			//         if (dataString.charAt(i) < 32 || dataString.charAt(i) > 127) 
			//         {
			//            return true;
			//         }
		}
		return false;
	}
	//added for FVU 5.0
	public boolean checkNonSpecialCharacter(String data)
	{
		Pattern p = Pattern.compile("[a-z0-9]", Pattern.CASE_INSENSITIVE);
		Matcher m = p.matcher(data);
		boolean b = m.find();

		if (b)
		{
			System.out.println("There is a non special character in my string");
			return true;
		}
		else
		{
			System.out.println("The string contains only special characterss");
			return false;
		}
		
	}
	//ended for FVU 5.0

	//added for FVU 5.0
	public boolean checkNonSpecialCharacterAndSpace(String data)
	{
		Pattern p = Pattern.compile("[a-z0-9\t ]", Pattern.CASE_INSENSITIVE);
		Matcher m = p.matcher(data);
		boolean b = m.find();

		if (b)
		{
			System.out.println("There is a non special character or space in my string");
			return true;
		}
		else
		{
			System.out.println("The string contains only special characterss");
			return false;
		}
		
	}
	//ended for FVU 5.0
	//added for FVU 5.0 - 2.146
	boolean isValidCharString_new(String dataString)
	{

		/*if (dataString.trim() == "" || dataString.trim().length() == 0)
		{
			return true;
		}*/
		for (int i = 0; i < dataString.length(); i++)
		{
			if ((dataString.charAt(i) < 32 || dataString.charAt(i) > 127) && dataString.charAt(i) != '\n' && dataString.charAt(i) != '\t')
			{
				return true;
			}
			//         if (dataString.charAt(i) < 32 || dataString.charAt(i) > 127) 
			//         {
			//            return true;
			//         }
		}
		return false;
	}
	//added for FVU 5.0 - 2.146
	///////////////////////////////////////////////////////////////////////////////////	
	boolean isAlphaSpace(String field)
	{
		if (field.trim() == "" || field.trim().length() == 0)
		{
			return true;
		}
		for (int i = 0; i < field.length(); i++)
		{
			if (!(Character.isLetter(field.charAt(i)) || field.charAt(i) == ' '))
			{
				return true;
			}
		}
		return false;
	}

	///////////////////////////////////////////////////////////////////////////////////
	boolean isAlphaNumSpace(String data)
	{
		if (data.trim() == "" || data.trim().length() == 0)
		{
			return true;
		}
		String field = data.trim();
		for (int j = 0; j < field.length(); j++)
		{
			if (!(Character.isLetterOrDigit(field.charAt(j)) || field.charAt(j) == ' '))
			{
				return true;
			}
		}
		return false;
	} //end of AlNum

	///////////////////////////////////////////////////////////////////////////////////////
	/*
	 * Function to check that 8th digigt of RRR Number is 9
	 */
	boolean eightthDigitOfRRRNum(String data)
	{
		if (data.trim() == "" || data.trim().length() == 0)
			return true;
		String field = data.trim();
		if (field.charAt(7) != '9') // For 8th digit we check charat(7) cause counter starts with zero
			return true;
		else
			return false;
	}

	/*
	 * Function to check that 8th digigt of RRR Number is 8
	 * and 9th digigt of RRR Number is 5
	 */

	boolean eightthNinethDigitOfRRRNum(String data)
	{
		if (data.trim() == "" || data.trim().length() == 0)
		{
			return true;
		}
		String field = data.trim();
		if (field.charAt(7) != '8') // For 8th digit we check charat(7) cause counter starts with zero
			return true;
		else if (field.charAt(8) != '9') // For 9th digit we check charat(8) cause counter starts with zero
			return true;
		else
			return false;
	}

	boolean isValidRrrNumber(String RRR_No)
	{
		if (Long.parseLong(RRR_No.trim()) == 0)
		{
			return true;
		}
		long longRRR_No;
		long longRRR_No1;
		int intRRR_No1, intRRR_No2;
		longRRR_No = Long.parseLong(RRR_No);
		longRRR_No1 = longRRR_No / 10;
		intRRR_No2 = (int) (longRRR_No % 10);
		intRRR_No1 = (int) (longRRR_No1 % 7);
		if (intRRR_No1 == intRRR_No2)
		{
			return false;
		}
		else
		{
			return true;
		}
	}

	//		///////////////    VALIDATE STRING AS NULL     ////////////////////// 	
	boolean nullFieldCheck(String text)
	{
		if (text.trim() == "" || text.trim().length() == 0)
		{
			return true;
		}
		if (text.length() == 0)
		{
			return (true);
		} //IF
		else
		{
			return (false);
		} //ELSE

	} //CLOSING METHOD isFieldNull			

	//		///////////////// VALIDATE NEGATIVE DECIMAL FIGURE ///////////////////////////////////////////////
	boolean isNegativeDecimalNumber(String data)
	{
		String field = data.trim();
		if (field.trim() == "" || field.trim().length() < 4)
		{
			return true;
		}

		for (int i = 0; i < data.length(); i++)
		{
			if ((data.charAt(i) < 32 || data.charAt(i) > 127))
			{
				return true;
			}
		}
		if(field.charAt(0)=='+')
		{
			return true;
		}

		try
		{
			Double.parseDouble(field);
		}
		catch (Exception e)
		{

			return true;
		}

		if (field.charAt(field.length() - 3) != '.')
		{
			return true;
		}

		for (int localI = 0; localI < field.length(); localI++)
		{
			if (!(field.charAt(localI) > 47 && field.charAt(localI) < 58) && !(field.charAt(localI) == 46) && !(field.charAt(0) == 45))
			{
				return true;
			}

			if ((field.charAt(localI) == 46) && !((field.length() - localI) == 3))
			{
				return true;
			}

			if ((field.charAt(localI) == 46) && (localI == 0))
			{
				return true;
			}

			if (Double.parseDouble(field) > 0)
			{
				return true;
			}

		}
		return false;

	}

	//////////////////////////////  VALIDATE DECIMAL NUMBER  ////////////////////////////
	/*
	 *  To check if the Number is a VALID POSITIVE DECIMAL with 2 Decimal digits.
	 */

	boolean isDecimalNumber(String data)
	{
		String Field = data.trim();
		if (Field.trim() == "" || Field.trim().length() < 4 || Field.length() < 4)
		{
			return true;
		}

		for (int i = 0; i < data.length(); i++)
		{
			if ((data.charAt(i) < 32 || data.charAt(i) > 127))
			{
				return true;
			}
		}
		if(Field.charAt(0)=='+')
		{
			return true;
		}

		try
		{
			Double.parseDouble(Field);
		}
		catch (Exception e)
		{

			return true;
		}

		if (Field.charAt(Field.length() - 3) != '.')
		{
			return true;
		}

		for (int localI = 0; localI < Field.length(); localI++)
		{
			if (!(Field.charAt(localI) > 47 && Field.charAt(localI) < 58) && !(Field.charAt(localI) == 46))
			{
				return true;
			}

			if ((Field.charAt(localI) == 46) && (localI == 0))
			{
				return true;
			}

			if ((Field.charAt(localI) == 46) && !((Field.length() - localI) == 3))
			{
				return true;
			}
		}
		return false;
	}

	//		//////////////////////////    Annual  Integer  //////////////////////////////////	
	public int checkNumeric(String data, int length)
	{
		if (data == null)
		{
			return 3;
		}
		String testNumber = data.trim();
		if (testNumber.trim() == "" || testNumber.trim().length() == 0)
		{
			return 3;
		}
		if (testNumber == null)
		{
			return 2;
		}
		if (testNumber.length() > length)
		{
			return 2;
		}

		for (int i = 0; i < testNumber.length(); i++)
		{
			if (!(testNumber.charAt(i) > 47 && testNumber.charAt(i) < 58))
			{
				return 3;
			}
		}

		return 4;
	}

	//		///////////////// VALIDATE FLOAT FIGURE ///////////////////////////////////////////////
	boolean isFloatNumber(String data)
	{
		String Field = data.trim();
		if (data.trim() == "" || data.trim().length() == 0 || data.trim().length() < 4 || data.length() < 4)
		{
			return true;
		}

		for (int i = 0; i < data.length(); i++)
		{
			if ((data.charAt(i) < 32 || data.charAt(i) > 127))
			{
				return true;
			}
		}
		if(Field.charAt(0)=='+')
		{
			return true;
		}

		try
		{
			Double.parseDouble(Field);
		}
		catch (Exception e)
		{
			return true;
		}

		if (Field.charAt(Field.length() - 3) != '.')
		{
			return true;
		}

		for (int localI = 0; localI < Field.length(); localI++)
		{
			if (!(Field.charAt(localI) > 47 && Field.charAt(localI) < 58) && !(Field.charAt(localI) == 46) && !(Field.charAt(0) == 45))
			{
				return true;
			}

			if ((Field.charAt(localI) == 46) && !((Field.length() - localI) == 3))
			{
				return true;
			}

			if ((Field.charAt(localI) == 46) && (localI == 0))
			{
				return true;
			}

		}
		return false;

	}

	///   VALIDATING E-MAIL   ////////
	boolean isValidEmail(String data)
	{
		String field = data.trim();
		if(data.length()!= data.trim().length())
		{
			return true;
		}
		if (field.trim() == "" || field.trim().length() == 0)
		{
			return true;
		}

		if (isValidCharString(field))
		{
			return true;
		}

		for (int j = 0; j < field.length(); j++)
		{
			
			if (field.charAt(j) == ' ')
			{
				return true;
			}
		}
		//  Previous Validation		
		//		for (int j = 0; j < field.length(); j++)
		//			{
		//				if(!Character.isLetterOrDigit(field.charAt(j)) && !(field.charAt(j) == '@') && !(field.charAt(j) == '.') && !(field.charAt(j) == '_') && !(field.charAt(j) == '-'))
		//				{
		//					return true;
		//				}
		//			}
		//		
//		if (field.charAt(0) == '@' || field.charAt(0) == '.')   commented by amit for FVU 2.141
//		{
//			return true;
//		}

//		if (field.charAt(field.length() - 1) == '@' || field.charAt(field.length() - 1) == '.')
//		{
//			return true;   commented by amit for FVU 2.141
		//}

         //Added By amit for FVU 2.141
		
		//To check if the last character is an alphabet or not
		
		int lastch=field.charAt(field.length() - 1);
		boolean alpflag=false;
		if(!((lastch>=65 && lastch<=90)||(lastch>=97 && lastch<=122)))
		{
			
			return true;
			
		}

		//To check character other than "@ . _-" 
		for (int j = 0; j < field.length(); j++)
		  {
			  int asc=field.charAt(j);
			
		    if(!((asc>=48 && asc<=57)||(asc>=64 && asc<=90)||(asc>=97 && asc<=122)||(asc==46||asc==45||asc==95)))
		     {
			   return true;
			   
		     }
		  
		   //To check th econsecutive special characters in the email
		    else
		    {
		    	if(j==0 || j==field.length()-1)
		    	{
		    		continue;
		    	}
		    		
			    else if((asc=='@'||asc=='.'||asc=='_'||asc=='-') && ((field.charAt(j+1)=='@'||field.charAt(j+1)=='.'||field.charAt(j+1)=='-'||field.charAt(j+1)=='_') || (field.charAt(j-1)=='@'||field.charAt(j-1)=='.'||field.charAt(j-1)=='-'||field.charAt(j-1)=='_')))
			    {
			    	
			    	return true;
			    	
			    }
		    }
		  
		    }
		if (field.charAt(0) == '@' || field.charAt(0) == '.'||field.charAt(0)=='-'||field.charAt(0)=='_')
		{
			return true;
		}
     //Email ID should not contain any special character or only numbers after last period (.)
		
		for(int i=field.lastIndexOf(".") + 1;i<field.length();i++)
		{
			if(!((field.charAt(i)>=65 && field.charAt(i)<=90)||(field.charAt(i)>=97 && field.charAt(i)<=122)))
			{
				
				return true;
			}
			else
			{
				
				alpflag=true;
			}
		
		}
		if(alpflag)
		{ 
		  
			
			if(field.substring((field.lastIndexOf(".")+1)).length()<2)
			{
				return true;
				
			}
			
		}
		//At least one and maximum two periods (.) should come after "@" symbol.
		int localCounter = 0;
		
		for(int i=field.lastIndexOf("@") + 1;i<field.length();i++)
		{
			  
			
			if(field.charAt(i)=='.')
			  {
				localCounter++;
				  
			  }
			
			
		}
		
		if(localCounter==0||localCounter>3)
		{
			return true;
			
		}
		//End Amit for FVU 2.141
		
		
		int localCount = 0;
		int dotPos = 0;
		int ratePos = 0;
		for (int j = 0; j < field.length(); j++)
		{
			if (field.charAt(j) == '@')
			{
				ratePos = j;
				if (field.charAt(j + 1) == '.')
				{
					return true;
				}
				localCount++;
				if (localCount > 1)
				{
					return true;
				}
			}
		}
		if (localCount == 0)
		{
			return true;
		}

		for (int x = 0; x < field.length(); x++)
		{
			if (field.charAt(x) == '.')
			{
				dotPos = x;

				if ((x + 1) != field.length())
				{
					if (field.charAt(x + 1) == '.')
					{
						return true;
					}
				}
			}

		}

		if (dotPos < ratePos)
		{
			return true;
		}

		return false;
	}

	//////////   Annual CHECK NUMERIC  //////////
	boolean isNumber(String data)
	{
		String field = data.trim();
		if (field.trim() == "" || field.trim().length() == 0)
		{
			return false;
		}

		for (int i = 0; i < data.length(); i++)
		{
			if ((data.charAt(i) < 32 || data.charAt(i) > 127))
			{
				return true;
			}
		}

		try
		{
			Integer.parseInt(field.charAt(0)+"");
			Integer.parseInt(field);
		}
		catch (Exception e)
		{
			return false;
		}

		if (Integer.parseInt(field) < 0)
		{
			return false;
		}
		return true;
	}

	//////////////      Validate PAN   //////////////////////
    /**
     * Length should be 10,First 3 Characters should be between capital A to capital Z,
     * Characters 6,7,8 should be numeric(between 0 and 9),Fourth character should be
     * amongst 'P','H','C','J','F','A','T','B','L','G'.Fifth and tenth character
     *  should be between capital A to capital Z.
     */
	public boolean checkPan(String pan)
	{

		if (pan.trim().length() != 10 || pan.length() != 10)
		{
			return true;
		}
		for (int i = 0; i < 3; i++)
		{
			if (!(pan.charAt(i) > 64 && pan.charAt(i) < 91))
			{
				return true;
			}
		}

		for (int i = 5; i < 9; i++)
		{
			if (!(pan.charAt(i) > 47 && pan.charAt(i) < 58))
			{
				return true;
			}
		}

		if (pan.charAt(3) != 'P'
			&& pan.charAt(3) != 'H'
			&& pan.charAt(3) != 'C'
			&& pan.charAt(3) != 'J'
			&& pan.charAt(3) != 'F'
			&& pan.charAt(3) != 'A'
			&& pan.charAt(3) != 'T'
			&& pan.charAt(3) != 'B'
			&& pan.charAt(3) != 'L'
			&& pan.charAt(3) != 'G')
		{
			return true;
		}

		if (!(pan.charAt(4) > 64 && pan.charAt(4) < 91))
		{
			return true;
		}

		if (!(pan.charAt(9) > 64 && pan.charAt(9) < 91))
		{
			return true;
		}

		return false;
	}
	
	//CHANGE AMI
	boolean checkSpChar(String RPU)
	{
		int field = 0;
		int fieldLength = RPU.length();

		for (int j = 0; j < RPU.length(); j++)
		{
			if (!(Character.isLetterOrDigit(RPU.charAt(j))))
			field++;
		}
		if(field == fieldLength)
			return true;

		return false;	
	}
	//CHECK FOR VALUE ZERO
	boolean checkZero(String Code)
	{
		int field = 0;
		int fieldLength = Code.length();
		
		for (int j = 0; j < Code.length(); j++)
		{
			if (Code.charAt(j) == '0')
				field++;
		}
		if(field == fieldLength)
			return true;
		
		return false;
	}
	 //CHECK FOR 4TH DIGIT AS "P"
	  boolean checkPanForthDigit24Q(String pan1)
	  {
		  if(pan1.trim().length() != 10 || pan1.length() != 10)
					  return true;
		  if(pan1.charAt(3) != 'P')
		              return true;
		return false;              				
	  }
	  //CHECK FOR STATENAME 
	  boolean isValidState(String State)
	  {
	  	if(State.trim().length() > 2 || State.length() > 2)
	  	      return true;
	  	 if(State.trim().charAt(0)=='+')
	  	 {
	  		 return true;
	  	 }
	  	int StateCode = Integer.parseInt(State);      
	  	
	  	if(StateCode < 1 )
	  	 return true;
	  	
	  	 if(StateCode > 35)
	  	 if(StateCode != 99 )
	  	  return true;
	    
	  	return false;
	  }
	  //CHECK FOR Date of 'Bank Challan No / Transfer Voucher No'
	  boolean isDateLastDateOfQuarter(String date,String finyear,String quarter)
	  {
	  	String month = null;
	  	String day = null;
	  	String year = null;
	  	String date1 = null;
	  	if(date.trim().length() != 8 || date.length() != 8 || finyear.trim().length() != 6 || finyear.length() != 6 || quarter.trim().length() != 2 || quarter.length() != 2)
	  	{
	  		return true;
	  	}
	  	if(quarter.equals("Q1"))
	  	{
	  		year= finyear.substring(0, 4);
	  		month = "06";
	  		day = "30";
	  		date1 = day.trim() + month.trim() + year.trim();
	  	}
	  	if (quarter.equals("Q2"))
	  	{
			year= finyear.substring(0, 4);
	  		month = "09";
	  		day = "30";
			date1 = day.trim() + month.trim() + year.trim();
	  	}
		if (quarter.equals("Q3"))
		{
			year= finyear.substring(0, 4);
			month = "12";
			day = "31";
			date1 = day.trim() + month.trim() + year.trim();
		}
		if (quarter.equals("Q4"))
		{
			year= finyear.substring(0, 2) + finyear.substring(4, 6);
			month = "03";
			day = "31";
			date1 =  day.trim() + month.trim() + year.trim();
		}
		if (date.equals(date1))
	  	{
	  		return false;
	  	}
	  	else return true;
	  
	  }
	  //CHECK FOR DDO REGISTRATION NO
	  boolean checkDDORegistrationNo(String DDONumber,String Str)
	  {
	  	String modcheck = null;
		String lastDigit = null;
		String DDOStr = null;
		
	  	if(DDONumber.length() != 10 || DDONumber.trim().length() != 10)
	  	{
	  		return true;
	  	}
	  	 		
	  		if(!(Character.isLetterOrDigit(DDONumber.charAt(3)))) //4th Digit can be alphaNumeric
	  			return true;
	  			
			for (int i = 4; i < 9; i++) //5th to 9th Digit Numeric
			{
			if (!(DDONumber.charAt(i) > 47 && DDONumber.charAt(i) < 58))
				{
					return true;
				}
			}
	  		if(!(DDONumber.charAt(9) > 64 && DDONumber.charAt(9) < 72))
	  			return true;
	  		
	  		if(DDONumber.charAt(9) == 'A')
				lastDigit = "0";
			if(DDONumber.charAt(9) == 'B')
				lastDigit = "1";
			if(DDONumber.charAt(9) == 'C')
				lastDigit = "2";
			if(DDONumber.charAt(9) == 'D')
				lastDigit = "3";
			if(DDONumber.charAt(9) == 'E')
				lastDigit = "4";
			if(DDONumber.charAt(9) == 'F')
				lastDigit = "5";
			if(DDONumber.charAt(9) == 'G')
				lastDigit = "6";						
																			
			modcheck = DDONumber.substring(4,9) + lastDigit.trim();
	  		
			if(isValidRrrNumber(modcheck)) //Mod Check For Last Digit 
	  		 	return true;
	  		
	  		DDOStr = Str + DDONumber.substring(3,10);
	  		
//			System.out.println("DDOStr"+DDOStr);
	  		
	  		if(DDONumber.equals(DDOStr))	
	  			return false;
	  		else 
	  			return true;	
	  	}		
	  
	
	  //END

	//////////     Validate TAN    ///////////////////////////////
    /**
     * Length should be 10, First 3 Characters should be among the 36 RCCs, 
     * First 3 Characters should be between capital A to capital Z,
     * Fourth character should be letter or digit and if letter then should be be between capital A to capital Z,
     * 5th,6th,7th,8th,9th character should be numberic(between 0 and 9). 
     * If integer of 5th,6th,7th,8th,9th character mod 7 is 0 the last character of TAN should be A. 
     * If integer of 5th,6th,7th,8th,9th character mod 7 is 1 the last character of TAN should be B.
     * If integer of 5th,6th,7th,8th,9th character mod 7 is 2 the last character of TAN should be C.
     * If integer of 5th,6th,7th,8th,9th character mod 7 is 3 the last character of TAN should be D.
     * If integer of 5th,6th,7th,8th,9th character mod 7 is 4 the last character of TAN should be E.
     * If integer of 5th,6th,7th,8th,9th character mod 7 is 5 the last character of TAN should be F.
     * If integer of 5th,6th,7th,8th,9th character mod 7 is 6 the last character of TAN should be G.
     * 
     */

	boolean checkTan(String tan)
	{
		int checkBit;
		if (tan.trim().length() != 10)
		{
			return true;
		}
		String subtan = tan.substring(0, 3);
		String midSubtan = tan.substring(4, 9);
		String endSubtan = tan.substring(9, 10);

		/* if(FileValidatorInterface.TDS_FVU_RCC.indexOf(subtan) == -1)
		 {
		     return true;
		 }
		*/

		////////////***************
		int rccFlag = 0;
		for (int localR = 0; localR < TDS_FVU_RCC.length; localR++)
		{
			if (subtan.equals(TDS_FVU_RCC[localR]))
			{
				rccFlag = 1;
				break;
			}
		}
		if (rccFlag == 0)
		{
			return true;
		}
		////////////***************
		for (int i = 0; i < 3; i++)
		{
			if (!(subtan.charAt(i) > 64 && subtan.charAt(i) < 91))
			{
				return true;
			}
		}

		if (!Character.isLetterOrDigit(tan.charAt(3)))
		{
			return true;
		}

		if (Character.isLetter(tan.charAt(3)))
		{
			if (!(tan.charAt(3) > 64 && tan.charAt(3) < 91))
			{
				return true;
			}

		}
		for (int i = 0; i < 5; i++)
		{
			if (!(midSubtan.charAt(i) > 47 && midSubtan.charAt(i) < 58))
			{
				return true;
			}
		}

		checkBit = Integer.parseInt(midSubtan) % 7;

		if (checkBit == 0 && !(endSubtan.charAt(0) == 'A' || endSubtan.charAt(0) == 'H'))
		{
			return true;
		}
		else if (checkBit == 1 && !(endSubtan.charAt(0) == 'B'|| endSubtan.charAt(0) == 'I'))
		{
			return true;
		}
		else if (checkBit == 2 && !(endSubtan.charAt(0) == 'C'|| endSubtan.charAt(0) == 'J'))
		{
			return true;
		}
		else if (checkBit == 3 && !(endSubtan.charAt(0) == 'D'|| endSubtan.charAt(0) == 'K'))
		{
			return true;
		}
		else if (checkBit == 4 && !(endSubtan.charAt(0) == 'E'|| endSubtan.charAt(0) == 'L'))
		{
			return true;
		}
		else if (checkBit == 5 && !(endSubtan.charAt(0) == 'F'|| endSubtan.charAt(0) == 'M'))
		{
			return true;
		}
		else if (checkBit == 6 && !(endSubtan.charAt(0) == 'G'|| endSubtan.charAt(0) == 'N'))
		{
			return true;
		}
		return false;
	}
	// added by faizan for FVU 2.144
	
	boolean checkTanForbh(String tan){
		
		String subtan = tan.substring(0, 3);
		int rccFlag = 0;
		for (int localR = 0; localR < TDS_FVU_RCC.length; localR++)
		{
			if (subtan.equals(TDS_FVU_RCC[localR]))
			{
				rccFlag = 1;
				break;
			}
		}
		if (rccFlag == 0)
		{
			return true;
		}
		return false;
		}
	// ended for FVU 2.144

	///////       Check if financial year is present or past year  ////////////////////////		
	boolean checkFinYear(String field)
	{
		if (field.trim() == "" || field.trim().length() == 0)
		{
			return true;
		}

		if (isNumber(field))
		{
			int financialyr = Integer.parseInt(field);
			int first_f = financialyr / 10000;
			int second_f = financialyr % 100;

			Calendar cal = new GregorianCalendar();
			int year = cal.get(Calendar.YEAR);
			if (year < ((first_f * 100) + second_f))
				return true;
		}
		else
			return true;

		return false;
	}

	/////////////  Check Name   ///////////

	boolean testName(String data)
	{
		if (data.trim() == "" || data.trim().length() == 0)
		{
			return true;
		}
		String nameField = data.trim();
		int countalph = 0;
		int counterSpace = 0;
		int countApostrophe = 0;

		for (int i = 1; i < nameField.length(); i++)
		{
			if (!(nameField.charAt(i) > 64 && nameField.charAt(i) < 91) && !(nameField.charAt(i) > 96 && nameField.charAt(i) < 123) && !(nameField.charAt(i) == ' ') && !(nameField.charAt(i) == 39))
			{
				return true;
			}
		}

		for (int j = 1; j < nameField.length(); j++)
		{
			if ((nameField.charAt(j) > 64 && nameField.charAt(j) < 91) || (nameField.charAt(j) > 96 && nameField.charAt(j) < 123))
			{
				countalph = 1;
				break;
			}
		}

		for (int j = 1; j < nameField.length(); j++)
		{
			if (nameField.charAt(j) == ' ')
			{
				if (nameField.charAt(j + 1) == 32)
				{
					counterSpace = 1;
					break;
				}
			}
		}

		for (int j = 1; j < nameField.length(); j++)
		{
			if (nameField.charAt(j) == 39)
			{
				if (nameField.charAt(j + 1) == 39 || nameField.charAt(j + 1) == ' ')
				{
					countApostrophe = 1;
				}
			}
		}

		if (countalph == 0 || counterSpace != 0 || countApostrophe != 0)
		{
			return true;
		}

		return false;
	}

	///////////   Check Date if future Date      //////////
	boolean isFutureDate(String date)
	{
		if (date.trim().length() != 8 || date.length() != 8)
		{
			return true;
		}

		Calendar cal1 = Calendar.getInstance();

		Calendar cal2 = new GregorianCalendar(Integer.parseInt(date.substring(4, 8)), Integer.parseInt(date.substring(2, 4)) - 1, Integer.parseInt(date.substring(0, 2)));
		if (cal1.before(cal2))
		{
			return true;
		}
		return false;
	}

	//////  Check if Date is Greater then RRRDatePresentDate /////
	boolean isDateGreaterThenRRRDatePresentDate(String date, Calendar RRRDatePresentDate)
	{
		if (date.trim().length() != 8 || date.length() != 8)
		{
			return true;
		}

		Calendar cal2 = new GregorianCalendar(Integer.parseInt(date.substring(4, 8)), Integer.parseInt(date.substring(2, 4)) - 1, Integer.parseInt(date.substring(0, 2)));

		if (cal2.after(RRRDatePresentDate))
		{
			return true;
		}
		return false;
	}

	//	/////////   Check Date IF Before Financial Year      //////////
	/**
	 * @return true if Date1 is prior to Financial year or if (date or financial year is incorrect)
	 *         false if Date1 is not prior to Financial year
	 */
	boolean isDateAfterFinYear(String date1, String finyear)
	{
		if (isNumber(date1) && isNumber(finyear))
		{
			if (date1.trim().length() != 8 || date1.length() != 8 || finyear.trim().length() != 6 || finyear.length() != 6)
			{
				return true;
			}

			Calendar cal1 = new GregorianCalendar(Integer.parseInt(date1.substring(4, 8)), Integer.parseInt(date1.substring(2, 4)) - 1, Integer.parseInt(date1.substring(0, 2)));

			Calendar cal2 = new GregorianCalendar(Integer.parseInt(finyear) / 100, 3, 1);
			if (cal1.before(cal2))
			{
				return true;
			}
			return false;
		}
		else
			return true;
	}

//	/////////   Check Date IF in previous Financial Year to current  FY   //////////Added for FVU 4.0

	/**
	 * @return true if date or financial year is incorrect
	 *         false if Date1 is correct
	 */
	boolean isDateAfterPrevFinYear(String date1, String finyear)
	{
		if (isNumber(date1) && isNumber(finyear))
		{
			if (date1.trim().length() != 8 || date1.length() != 8 || finyear.trim().length() != 6 || finyear.length() != 6)
			{
				return true;
			}

			Calendar cal1 = new GregorianCalendar(Integer.parseInt(date1.substring(4, 8)), Integer.parseInt(date1.substring(2, 4)) - 1, Integer.parseInt(date1.substring(0, 2)));

			Calendar cal2 = new GregorianCalendar((Integer.parseInt(finyear) / 100) - 1, 3, 1);
			if (cal1.before(cal2))
			{
				return true;
			}
			return false;
		}
		else
			return true;
	}
	//	/////////   Check Date IF in Financial Year      //////////
	public boolean isDateInFinancialYr(String date, String FinancialYear)
	{
		if (isNumber(date) && isNumber(FinancialYear))
		{
			String firstYr = null;
			String secondYr = null;

			if (date.trim().length() != 8 || FinancialYear.trim().length() != 6)
			{
				return true;
			}

			Calendar cal1 = new GregorianCalendar(Integer.parseInt(date.substring(4, 8)), Integer.parseInt(date.substring(2, 4)) - 1, Integer.parseInt(date.substring(0, 2)));

			Calendar cal2 = new GregorianCalendar(Integer.parseInt(FinancialYear) / 100, 3, 1);

			if (FinancialYear.substring(4, 6).equals("00"))
			{
				secondYr = Integer.toString((Integer.parseInt(FinancialYear) / 100) + 1);
			}
			else
				secondYr = FinancialYear.substring(0, 2) + FinancialYear.substring(4, 6);

			Calendar cal3 = new GregorianCalendar(Integer.parseInt(secondYr), 3, 31);

			if (cal1.before(cal2) || cal1.after(cal3))
			{
				return true;
			}
			else
				return false;

		}
		else
			return true;
	}

	///////////  Employment date within quater of Financial Year /////////

	public boolean employmentDateWithinFinQuat(String empDate, String finYear, String quater)
	{
		if (isNumber(empDate) && isNumber(finYear))
		{
			String firstYr = null;
			String secondYr = null;
			if (empDate.trim().length() != 8 || finYear.trim().length() != 6)
			{
				return true;
			}

			Calendar cal1 = new GregorianCalendar(Integer.parseInt(empDate.substring(4, 8)), Integer.parseInt(empDate.substring(2, 4)) - 1, Integer.parseInt(empDate.substring(0, 2)));
			if (quater.equals("Q1"))
			{
				Calendar cal2 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 3, 1);
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 5, 30);

				if (cal1.before(cal2))
					return true;

				if (cal1.after(cal3))
					return true;

			}
			else if (quater.equals("Q2"))
			{
				Calendar cal2 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 6, 1);
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 8, 30);

				if (cal1.before(cal2))
					return true;

				if (cal1.after(cal3))
					return true;

			}
			else if (quater.equals("Q3"))
			{
				Calendar cal2 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 9, 1);
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 11, 31);

				if (cal1.before(cal2))
					return true;

				if (cal1.after(cal3))
					return true;

			}
			else if (quater.equals("Q4"))
			{
				firstYr = finYear.substring(0, 4);
				if (finYear.substring(4, 6).equals("00"))
				{
					secondYr = Integer.toString((Integer.parseInt(finYear) / 100) + 1);
				}
				else
					secondYr = finYear.substring(0, 2) + finYear.substring(4, 6);

				Calendar cal2 = new GregorianCalendar(Integer.parseInt(secondYr), 0, 1);
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(secondYr), 2, 31);

				if (cal1.before(cal2))
					return true;

				if (cal1.after(cal3))
					return true;

			}

			return false;
		}
		else
			return true;

	}

	//	/////////  Employment From-Date prior to quater/////////

	public boolean employmentFromDateBeforeQuatEnd(String empDate, String finYear, String quater)
	{
		if (isNumber(empDate) && isNumber(finYear))
		{
			String firstYr = null;
			String secondYr = null;
			if (empDate.trim().length() != 8 || finYear.trim().length() != 6)
			{
				return true;
			}

			Calendar cal1 = new GregorianCalendar(Integer.parseInt(empDate.substring(4, 8)), Integer.parseInt(empDate.substring(2, 4)) - 1, Integer.parseInt(empDate.substring(0, 2)));

			if (quater.equals("Q1"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 5, 30);

				if (cal1.after(cal3))
					return true;

			}
			else if (quater.equals("Q2"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 8, 30);

				if (cal1.after(cal3))
					return true;

			}
			else if (quater.equals("Q3"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 11, 31);

				if (cal1.after(cal3))
					return true;

			}
			else if (quater.equals("Q4"))
			{
				firstYr = finYear.substring(0, 4);
				if (finYear.substring(4, 6).equals("00"))
				{
					secondYr = Integer.toString((Integer.parseInt(finYear) / 100) + 1);
				}
				else
					secondYr = finYear.substring(0, 2) + finYear.substring(4, 6);

				Calendar cal3 = new GregorianCalendar(Integer.parseInt(secondYr), 2, 31);

				if (cal1.after(cal3))
					return true;

			}

			return false;
		}
		else
			return true;

	}

	/// Date within Financial Year and Before the Last Date of Quater //////////
	public boolean dateWithinFinancialYearBefQuatEndDate(String date, String finYear, String quater)
	{
		if (isNumber(date) && isNumber(finYear))
		{
			String firstYr = null;
			String secondYr = null;
			if (date.trim().length() != 8 || finYear.trim().length() != 6)
			{
				return true;
			}

			Calendar cal2 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 3, 1);

			Calendar cal1 = new GregorianCalendar(Integer.parseInt(date.substring(4, 8)), Integer.parseInt(date.substring(2, 4)) - 1, Integer.parseInt(date.substring(0, 2)));

			if (cal1.before(cal2))
			{
				return true;
			}

			if (quater.equals("Q1"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 5, 30);

				if (cal1.after(cal3))
					return true;
			}
			else if (quater.equals("Q2"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 8, 30);

				if (cal1.after(cal3))
					return true;
			}
			else if (quater.equals("Q3"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 11, 31);

				if (cal1.after(cal3))
					return true;

			}
			else if (quater.equals("Q4"))
			{
				firstYr = finYear.substring(0, 4);
				if (finYear.substring(4, 6).equals("00"))
				{
					secondYr = Integer.toString((Integer.parseInt(finYear) / 100) + 1);
				}
				else
					secondYr = finYear.substring(0, 2) + finYear.substring(4, 6);

				Calendar cal3 = new GregorianCalendar(Integer.parseInt(secondYr), 2, 31);

				if (cal1.after(cal3))
					return true;
			}

			return false;
		}
		else
			return true;

	}
	//	/ END----Date within Financial Year and Before the Last Date of Quater //////////

	/**
	 * This method checks whether a the specified date is less than or equal
	 * to the end date of finanacial year given
	 * @return true if date is less than or equal to the end date of finanacial year given
	 */
	public boolean isDateBeforeFinYearEndDate(String date, String finYear)
	{
		Calendar cal1 = new GregorianCalendar(Integer.parseInt(date.substring(4, 8)), Integer.parseInt(date.substring(2, 4)) - 1, Integer.parseInt(date.substring(0, 2)));
		Calendar cal2 = new GregorianCalendar(Integer.parseInt(finYear) / 100 + 1, 3, 1);
		return cal1.before(cal2);
	}

	///////////////////   Positive or Negative Decimal //////////
	boolean isPositiveNegativeDecimalNumber(String data)
	{
		String field = data.trim();
		if (field.trim() == "" || field.trim().length() < 4)
		{
			return true;
		}

		if(field.charAt(0)=='+')
		{
			return true;
		}
		try
		{
			Double.parseDouble(field);
		}
		catch (Exception e)
		{

			return true;
		}

		if (field.charAt(field.length() - 3) != '.')
		{
			return true;
		}

		for (int localI = 0; localI < field.length(); localI++)
		{
			if (!(field.charAt(localI) > 47 && field.charAt(localI) < 58) && !(field.charAt(localI) == 46) && !(field.charAt(0) == 45))
			{
				return true;
			}

			if ((field.charAt(localI) == 46) && !((field.length() - localI) == 3))
			{
				return true;
			}

			if ((field.charAt(localI) == 46) && (localI == 0))
			{
				return true;
			}
		}
		return false;
	}

	/*
		 * method to convert number into 2 decimal point string,
		 * if we print double it will show it in exponential form, so we multiply it with 100 and convert 
		 * into long than from long convert it into string and add . before last two character
		 */
	public String changeNumberFormat(double number)
	{
		if (number == 0)
		{
			return "0.00";
		}
		else
		{
			// d4 = Math.round((double)(d4 * 100)) /100.0;
			//	  long l = (long) (number * 100); // converting Amount into Paisa and converting to long
			long l = Math.round((double) (number * 100));
			String amount = Long.toString(l); // converting amount to String
			int length = amount.length();

			if (length == 1)
			{
				return "0.0" + l; // appending . between Rs and Paisa part
			}
			else if (length == 2)
			{
				return "0." + l;
			}

			String rupees = amount.substring(0, (length - 2)); // separating Rs part and Paisa part
			String paisa = amount.substring((length - 2), length);
			return rupees + "." + paisa; // appending . between Rs and Paisa part
		}
	}
    
    
  //-----code changed for validation of structurally valid deductee ---Manvendra Singh 05/09/2009
  //----------------------------------------------------------------------------
              
    public boolean NotInNonValidatonlist(String YrQrt)
    {
        int length = Parameters.NonValidation_period.length ;
        while (length > 0)
        {
            if(YrQrt.equals(Parameters.NonValidation_period[--length].trim()))
            {
                return false;
            }
        }
        return true;
    }
  //----------------------------------------------------------------------------
    //Added by Abhishek on 27/02/2011
    public boolean dateBefFinYr(String date, String finYear)
	{
		if (isNumber(date) && isNumber(finYear))
		{
			if (date.trim().length() != 8 || finYear.trim().length() != 6)
			{
				return true;
			}

			Calendar cal2 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 3, 1);

			Calendar cal1 = new GregorianCalendar(Integer.parseInt(date.substring(4, 8)), Integer.parseInt(date.substring(2, 4)) - 1, Integer.parseInt(date.substring(0, 2)));

			if (cal1.before(cal2))
			{
				return true;
			}

			return false;
		}
		else
			return true;

	}
    
    public boolean dateBefQuatEndDate(String date, String finYear, String quater)
	{

			String firstYr = null;
			String secondYr = null;

			Calendar cal1 = new GregorianCalendar(Integer.parseInt(date.substring(4, 8)), Integer.parseInt(date.substring(2, 4)) - 1, Integer.parseInt(date.substring(0, 2)));


			if (quater.equals("Q1"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 5, 30);

				if (cal1.after(cal3))
					return true;
			}
			else if (quater.equals("Q2"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 8, 30);

				if (cal1.after(cal3))
					return true;
			}
			else if (quater.equals("Q3"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 11, 31);

				if (cal1.after(cal3))
					return true;

			}
			else if (quater.equals("Q4"))
			{
				firstYr = finYear.substring(0, 4);
				if (finYear.substring(4, 6).equals("00"))
				{
					secondYr = Integer.toString((Integer.parseInt(finYear) / 100) + 1);
				}
				else
					secondYr = finYear.substring(0, 2) + finYear.substring(4, 6);

				Calendar cal3 = new GregorianCalendar(Integer.parseInt(secondYr), 2, 31);

				if (cal1.after(cal3))
					return true;
			}

			return false;

	}
	//	/ END----Date within Financial Year and Before the Last Date of Quater //////////
  //Added by Shalin for FVU 4.1
    public boolean dateBefQuatStartDate(String date, String finYear, String quater)
	{
			String firstYr = null;
			String secondYr = null;

			Calendar cal1 = new GregorianCalendar(Integer.parseInt(date.substring(4, 8)), Integer.parseInt(date.substring(2, 4)) - 1, Integer.parseInt(date.substring(0, 2)));


			if (quater.equals("Q1"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 3, 1);

				if (cal1.before(cal3))
					return true;
			}
			else if (quater.equals("Q2"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 6, 1);

				if (cal1.before(cal3))
					return true;
			}
			else if (quater.equals("Q3"))
			{
				Calendar cal3 = new GregorianCalendar(Integer.parseInt(finYear) / 100, 9, 1);

				if (cal1.before(cal3))
					return true;

			}
			else if (quater.equals("Q4"))
			{
				firstYr = finYear.substring(0, 4);
				if (finYear.substring(4, 6).equals("00"))
				{
					secondYr = Integer.toString((Integer.parseInt(finYear) / 100) + 1);
				}
				else
					secondYr = finYear.substring(0, 2) + finYear.substring(4, 6);

				Calendar cal3 = new GregorianCalendar(Integer.parseInt(secondYr), 0, 1);

				if (cal1.before(cal3))
					return true;
			}
			return false;

	}

	//	/ END----Date within Financial Year //////////
  //added by shruti for fuv 5.5 
    public boolean  isValidNameString(String dataString)
	{		
		int leng =dataString.length();
		//System.out.println(leng);
		int count = 0;
		
		boolean flag=true;
		int countmatched=0;
		if (dataString == "" || dataString.length() == 0 || dataString.length() == 1)
		{
			flag = false;
			//System.out.println("blank or single string");
		}
		else
		{
			//	System.out.println("entering last case");
				for (int i = 0; i < dataString.length(); i++)
				{			
					if(dataString.charAt(0) == dataString.charAt(i))
					{
						count++;
					}
				}
				if (count == leng){
					flag = false;
				}
	    }
		return flag;		
	}
    
    public boolean isAlphanumeric(String str) {
        for (int i=0; i<str.length(); i++) {
            char c = str.charAt(i);
            if (!Character.isDigit(c) && !Character.isLetter(c))
                return false;
        }

        return true;
    }
} //CLASS FIELDVALIDATION
